<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../common/meta';
import {
  NextStep as FeaturesCTA,
  SideNavigationVariant,
} from '../components/common/index.vue';
import {
  SolutionsHero,
  SolutionsResourceCards,
} from '../components/solutions/index.vue';
import {
  ByIndustryCaseStudies,
  ByIndustryIntro,
  ByIndustrySolutionsBlock,
} from '../components/solutions/by-industry/index.vue';
import {
  BySolutionBenefits,
  BySolutionIntro,
  BySolutionValueProp,
} from '../components/solutions/by-solution/index.vue';
import { CONTENT_TYPES } from '../common/content-types';
import { getClient } from '../plugins/contentful';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { enterpriseDataHelper } from '~/services/enterprise.service';

export default Vue.extend({
  components: {
    SolutionsHero,
    ByIndustryIntro,
    SideNavigationVariant,
    BySolutionIntro,
    BySolutionBenefits,
    BySolutionValueProp,
    ByIndustryCaseStudies,
    ByIndustrySolutionsBlock,
    SolutionsResourceCards,
    FeaturesCTA,
  },
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData({ i18n }: any) {
    try {
      const locale = convertToCaseSensitiveLocale(i18n.locale);
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '2Q6VFH6i1ywAiudpAX7TjD',
        include: 10,
        locale,
        [`fields.description.${locale}[exists]`]: true,
      });

      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;
      const enterprise = enterpriseDataHelper(items);
      return { items, enterprise, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).enterprise,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.enterprise = enterpriseDataHelper(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div class="overflow-clip">
    <SolutionsHero :data="enterprise['solutions_hero']" />
    <ByIndustryIntro :data="enterprise['by_industry_intro']" />
    <SideNavigationVariant :links="enterprise['side_navigation_links']">
      <div id="overview" data-slippers-scroll="overview">
        <BySolutionIntro :data="enterprise['by_solution_intro']" :offset="2" />
        <BySolutionBenefits
          :data="enterprise['by_solution_benefits']"
          :offset="2"
        />
      </div>
      <BySolutionValueProp
        id="benefits"
        :data="enterprise['by_solution_value_prop']"
        :justify-content="true"
        data-slippers-scroll="benefits"
      />
      <div
        id="capabilities"
        class="slp-my-96"
        data-slippers-scroll="capabilities"
      >
        <ByIndustrySolutionsBlock
          :data="enterprise['by_industry_solutions_block']"
          :offset="2"
        />
      </div>
      <ByIndustryCaseStudies
        id="case-studies"
        :data="enterprise['by_industry_case_studies']"
        :offset="2"
        data-slippers-scroll="case-studies"
      />
    </SideNavigationVariant>
    <SolutionsResourceCards :data="enterprise['solutions_resource_cards']" />
    <FeaturesCTA />
  </div>
</template>
